%% Load Data
clear all
close all
load Sininput
n = 1; % dataset #
sample_series(:,1) = SSBN13_LS(:);

par = [0.125638114	0.138252335	2691.246009	4.195614601	2.314478715	0.48689376	0.909958227	0.251631746	0.351130375	346.6842125	647.6167438	253.3868744	0.047496652	0.397917	0.27557334	0.14962266	0.2042];


%% Setting up problem (determining HR time series)

for n=1:length(sample_series(1,:))

    b = HighPassFilter_Window; %create filter transfer function from m-file
    P_Ao = filtfilt(b,1,sample_series(:,n)); %high pass filter time series

    P_in(:,n) = sample_series(:,n);

    N_ts = length(P_Ao);
    t_ts  = (0:1:N_ts-1)*0.01;

    % count number of waveforms and find tau's
    Nw = 0;
    for i = 1:N_ts-2
      if (P_Ao(i+1) > 0) && ( (P_Ao(i) < 0)||(P_Ao(i) == 0) )
          Nw = Nw + 1; %count waves
          tau(Nw) = interp1(P_Ao(i:i+2),t_ts(i:i+2),0); %solve for time at zero
          itau(Nw) = i; %sample number at zero
      end
    end

    HR_ts  = 60./(tau(2:Nw) - tau(1:Nw-1)); %beat-to-beat heartrate (bpm)
    t_HR_ts = ((tau(2:Nw) + tau(1:Nw-1))./2); %beat-to-beat times

    for i=1:(length(HR_ts)-1)
    if abs(HR_ts(i+1)-HR_ts(i))>50
        HR_ts(i+1)=HR_ts(i);
    end
    end

    HR_ts_cell{n,1} = num2cell(HR_ts);
    t_HR_ts_cell{n,1} = num2cell(t_HR_ts);

    clear P_Ao N_ts t_ts HR_ts t_HR_ts Nw tau itau

end
    
%% Run model
sse = OverallBaroreflexModel(par,P_in,sample_series,t_HR_ts_cell);
    